package Beispiel2;

import java.rmi.*;
import java.rmi.activation.*;

public class ActivatableImplementation extends Activatable
     implements Beispiel2.MeinRemoteInterface {

    // Konstruktor fr Aktivierung und Export; dieser Konstruktor wird
    // von der Methode ActivationInstantiator.newInstance whrend der
    // Aktivierung aufgerufen, um das Objekt zu konstruieren.
    //
    public ActivatableImplementation(ActivationID id, MarshalledObject data)
	throws RemoteException {
	// Registrieren des Objekts, welches das Aktivierungssystem
	// an einem anonymen Port anbietet (expportiert)
        //
	super(id, 0);
        System.out.println("ActivatableImplementation: Aufruf des Konstruktors");
    }

    // Implementation der Methode, welche in MeinRemoteInterface
    // deklariert wurde
    //
    public Object rufMichRemoteAuf() throws RemoteException {

	return "ActivatableImplementation: Der Aufruf war erfolgreich!";
    }
}
