package Beispiel2;

import java.rmi.*;
import java.rmi.activation.*;

public class MeinRemoteInterfaceImpl extends Activatable
    implements MeinRemoteInterface {

    // Konstruktor fr AKtivierung und EXport;
    // dieser Konstruktor wird von der Methode
    // ActivationInstantiator.newInstance whrend der
    // Aktivierung aufgerufen, um das Objekt zu konstruieren.
    //
    public MeinRemoteInterfaceImpl(ActivationID id, MarshalledObject data)
	throws RemoteException {

	// Registrieren des Objekts beim Aktivierungssystem
	// und export an einen anonymen Port.
	//
	super(id, 0);
    }

    // Implementation der in MeinRemoteInterface deklarierten Methoden
    //
    public Object rufMichRemoteAuf() throws RemoteException {

	return "MeinRemoteInterfaceImpl: erfolgreiche Ausfuehrung der \n" +
               "MeinRemoteInterfaceImpl: Methode 'rufMichRemoteAuf'";
    }
}
