package Beispiel3;

import java.rmi.*;
import java.rmi.activation.*;

public class MeineKlasse implements NochEinRemoteInterface {

    private String resultat = null;

      // Konstruktor fr Aktivierung und Export; dieser Konstruktor wird
      // von der Methode ActivationInstantiator.newInstance whrend der
      // Aktivierung aufgerufen, um das Objekt zu konstruieren.
      //
    public MeineKlasse(ActivationID id, MarshalledObject data)
	throws RemoteException {

      // Registrieren des Objekts beim Aktivierungssystem und
      // anschliessender Export an einen anonymen Port
      //
      System.out.println("MeineKlasse: Aufruf des Aktivierungs-Konstruktors");
      Activatable.exportObject(this, id, 0);
    }

      // Implementieren der Methode, die im Interface 'NochEineRemoteInterface'
      // definiert ist;
      // sie akzeptiert eine Zeichenkette, modifiziert diese und
      // liefert die modifizierte Zeichenkette zurck
      //
    public String rufDenServer(String strEingabe) throws RemoteException {

      System.out.println("MeineKlasse: Methode 'rufDenServer()'");
      resultat = strEingabe + " - Ja, ich bin hier!";
      return resultat;
    }
}
