package HelloWorldBeispiel;

import java.rmi.RemoteException;
import java.rmi.RMISecurityManager;
//import java.rmi.server.UnicastRemoteObject;
import javax.rmi.PortableRemoteObject;
//import java.rmi.Naming;
import javax.naming.*;

//public class HelloImpl extends UnicastRemoteObject
public class HalloImpl extends PortableRemoteObject

    implements Hallo {

    public HalloImpl() throws RemoteException {
        super();
    }

    public HalloImpl(String strName) throws RemoteException {
        super();
    }

    public String sagHallo() {
        return  "Hallo Du da!";
    }

    public static void main(String args[]) {
        System.out.println("HalloServer: Start");
        // Kreieren und installieren eines Security Manager
        if (System.getSecurityManager() == null) {
            System.out.println("HalloServer: Setzen des Security Managers");
	    System.setSecurityManager(new RMISecurityManager());
        }
        try {
	    // RMI: HalloImpl obj = new HalloImpl();
	    // RMI over IIOP:
            System.out.println("HalloServer: Instanzierung des HalloServers");
            HalloImpl obj = new HalloImpl("HalloServer");
            // RMI over IIOP:
            // Kreieren des JNDI Context
            System.out.println("HalloServer: Kreieren des initialNamingContext");
            Context initialNamingContext = new InitialContext();
	    // Binden der Objekt Instanz an den Namen "HalloServer" :
	    // RMI : Naming.rebind("HelloServer", obj);
            // RMI over IIOP:
            System.out.println("HalloServer: Binden des HalloServers an den initialNamingContext");
            initialNamingContext.rebind("HalloServer",obj);
	    System.out.println("HalloServer: an die Registry gebunden");
        } catch (Exception e) {
	    System.out.println("HalloServer: Impl Exception " + e.getMessage());
	    e.printStackTrace();
        }
    }
}
