package HelloWorld;

import java.io.*;

class XorOutputStream extends FilterOutputStream {

    /*
     * Byte zum Verschlsseln der Daten.
     * Default ist 10101010.
     */
    private byte pattern = (byte)(170 & 0xFF);

    /*
     * Konstruktor fr die Klasse XorOutputStream
     */
    public XorOutputStream(OutputStream out, byte pattern) {
        super(out);
        if (pattern != 0)
	    this.pattern = pattern;
    }

    /*
     * XOR't das Byte.
     */
    public void write(int b) throws IOException {
       out.write(b ^ pattern);
       out.flush();
    }

    /*
     * Schreiben von len Bytes
     */
    public void write(byte b[], int off, int len) throws IOException {
        for (int i = 0; i < len; i++)
            write(b[off + i]);
    }
}
