package MultiSocket;

import java.io.*;
import java.net.*;

class XorServerSocket extends ServerSocket {

    /*
     * Pattern mit dem entschlsselt und verschlsselt wird:
     * jedes Byte, welches gelesen oder geschrieben wird.
     */
    private byte pattern;

    /*
     * Konstruktor fr die Klasse XorServerSocket.
     */
    public XorServerSocket(int port, byte pattern) throws IOException {
        super(port);
        this.pattern = pattern;
    }

    /*
     * Kreieren eines Sockets vom Typus XorSocket und anschliessend Aufruf
     * von implAccept und warten auf Client Anfragen.
     */
    public Socket accept() throws IOException {
        Socket s = new XorSocket(pattern);
        implAccept(s);
        return s;
    }
}




