package spaceinvader.common;


public class GameProfile implements Identifiable, java.io.Serializable
{
    private String        fGalaxyName;
    private int           fNumberOfPlanets;
    private int           fNumberOfPlayers;
    private ID            fID;

    public GameProfile (String galaxyName, int numPlanets, int numPlayers)
    {
	String fGalaxyName = galaxyName;
	fNumberOfPlanets = numPlanets;
	fNumberOfPlayers = numPlayers;
	fID = new ID ();
    }

    public ID getID ()
    {
	return fID;
    }

    public String getGalaxyName ()
    {
	return fGalaxyName;
    }

    public int getNumberOfPlanets ()
    {
	return fNumberOfPlanets;
    }

    public int getNumberOfPlayers ()
    {
	return fNumberOfPlayers;
    }

}
