package HelloWorld;

import java.rmi.*;

public class HalloClient {
    private static String message = "";
    public static void main(String args[]) {
        System.out.println("HalloClient: Start");
	//kreieren und instanzieren des Security Manager
	if (System.getSecurityManager() == null)
	    System.setSecurityManager(new RMISecurityManager());
        System.out.println("HalloClient: SecurityManager wurde installiert");
        try {
            System.out.println("HalloClient: Lesen der Registry");
	    // zum Testen : Abfrage der Registry
      	    for (int i=0; i< Naming.list("rmi://localhost/").length; i++)
      				System.out.println("HalloClient: "+Naming.list("rmi://localhost/")[i]);
            System.out.println("HalloClient: es wurden "+Naming.list("rmi://localhost/").length + " Eintraege in der Registry gefunden!");
            System.out.println("HalloClient: Lesen der HalloXORServer Referenz aus der Registry");
            Hallo objXOR = (Hallo) Naming.lookup("/HalloXORServer");
            System.out.println("HalloClient: Aufruf der remote Methode Hallo.sagHallo()");
            message = objXOR.sagHallo();
            System.out.println(message);

            System.out.println("HalloClient: Lesen der HalloCompressionServer Referenz aus der Registry");
            Hallo objCompressed = (Hallo) Naming.lookup("/HalloCompressionServer");
            System.out.println("HalloClient: Aufruf der remote Methode Hallo.sagHallo()");
            message = objCompressed.sagHallo();
            System.out.println(message);
        } catch (Exception e) {
	    System.out.println("HalloClient Exception: " +
                               e.getMessage());
            e.printStackTrace();
        }
    }

}
